# set MPI compiler here
#MPIFC=scorep-mpif90
MPIFC=mpif90
CC=nvcc

#MPIFC=mpif90
#MPIFC=/home/cluster_software/openmpi_gfortran/bin/mpif90

###### GNU gfortran compiler ##################

# optimized mode
#FC_FLAGS=-std=f2008 -fimplicit-none -frange-check -fmax-errors=10 -pedantic -pedantic-errors -Waliasing -Wampersand -Wcharacter-truncation -Wline-truncation -Wsurprising -Wno-tabs -Wunderflow -ffpe-trap=invalid,zero,overflow -Wunused -Werror -O3 -finline-functions

# debug mode
#FC_FLAGS=-std=f2008 -fimplicit-none -frange-check -fmax-errors=10 -pedantic -pedantic-errors -Waliasing -Wampersand -Wcharacter-truncation -Wline-truncation -Wsurprising -Wno-tabs -Wunderflow -ffpe-trap=invalid,zero,overflow -Wunused -Werror -g -O0 -ggdb -fbacktrace -fbounds-check

###### INTEL ifort compiler ##################

# optimized mode
#FC_FLAGS=-xHost -fpe0 -ftz -assume buffered_io -assume byterecl -align sequence -std08 -implicitnone -gen-interfaces -warn all -O3 -check nobounds
#FC_FLAGS=-xHost -fpe0 -ftz -align sequence -std08 -implicitnone -O3 -check nobounds -pg -vec-report3
#FC_FLAGS=-xHost -fpe0 -ftz -assume buffered_io -assume byterecl -align sequence -std03 -diag-disable 6477 -implicitnone -gen-interfaces -warn all -O3 -check nobounds 
FC_FLAGS= -O3  -DENABLE_CUDA

# debug mode
#FC_FLAGS=-xHost -DENABLE_CUDA  -fpe0 -ftz -assume buffered_io -assume byterecl -align sequence -std08 -implicitnone -gen-interfaces -warn all -check all -debug -g -O0 -fp-stack-check -traceback -ftrapuv -g

# c
C_FLAGS= -O2 -DENABLE_CUDA
#CUDA_FLAGS = -gencode=arch=compute_80,code=\"sm_80,compute_80\"
CUDA_FLAGS = -pg --generate-line-info -arch=sm_80
##################################################################################################################################

# not sure if all the dependencies are right, thus turning off parallel compilation, since the code is small and compiles fast
.NOTPARALLEL:

SUB = config_mod.o domain_decomp_mod.o element_mod.o meshfem_mod.o mpi_mod.o specfem_mod.o addressing_mod.o acquisition_mod.o IO_mod.o 
SUBC = specfem_gpu.o kernel_specfem3D_GPU.o

#VPATH = ./:input/:./output:./modeling:./inversion:./regularization:./source:./regularization

LIBS = -lstdc++ -lcudart -L/opt/nvidia/hpc_sdk1/Linux_x86_64/23.1/cuda/lib64

default : rule_for_specfem_mini_app

all : rule_for_specfem_mini_app

rule_for_specfem_mini_app : specfem_mini_app.o $(SUB) $(SUBC)
	$(MPIFC) $(FC_FLAGS) specfem_mini_app.o  $(SUB) $(SUBC) $(LIBS) -o $(EXEC)xspecfem_mini_app

%.o: %.f90
	$(MPIFC) $(FC_FLAGS) -c -o $@ $<

# The rule that makes all object files from C sources:
%.o: %.cpp
	$(CC) $(C_FLAGS) -c -o $@ $<

%.o: %.cu
	$(CC) $(C_FLAGS) $(CUDA_FLAGS) -c -o $@ $<
#
# dependencies
#
specfem_mini_app.o :  config_mod.o  mpi_mod.o domain_decomp_mod.o meshfem_mod.o specfem_mod.o 
domain_decomp_mod.o : config_mod.o  mpi_mod.o addressing_mod.o 
element_mod.o  : config_mod.o
meshfem_mod.o : config_mod.o mpi_mod.o addressing_mod.o
mpi_mod.o :config_mod.o
specfem_mod.o : config_mod.o acquisition_mod.o meshfem_mod.o element_mod.o addressing_mod.o domain_decomp_mod.o mpi_mod.o IO_mod.o specfem_gpu.o kernel_specfem3D_GPU.o
addressing_mod.o : config_mod.o
acquisition_mod.o : config_mod.o element_mod.o mpi_mod.o
IO_mod.o :config_mod.o mpi_mod.o

clean :
	rm -f *.o *.mod *__genmod.?90 xspecfem_mini_app *~ *.x  */*~

realclean : clean
mrproper : clean
